//-------------------------------------------------------
//	illustrate call of dfgnbla from C++ program
// note:  actual name of external module:  _dfgnbla
//        always *OMIT* underscore (use dfgnbla) in C++ program.
//        *INCLUDE* underscore (use _dfgnbla) in linker list
//        unless your linker setup specifies otherwise
//-------------------------------------------------------

#include <iostream.h>
#include <conio.h>

//-------------------------------------------------------
//	declarations
//-------------------------------------------------------

extern "C" unsigned char dfgnbla(unsigned int);

//-------------------------------------------------------
//	variables
//-------------------------------------------------------
unsigned char bla_dummy;    
                            /* if you can remove bla_dummy and avoid
                               the 'null pointer assignment' error, then
                               remove it.  otherwise put bla_dummy 
                               as your 1st variable and move nothing to it.  
                               i wrote this with an old version of C++ 
                               [borland C++ 3.0, (c) 1992] and may have 
                               stumbled over a bug.  evidently, borland C++ 3.0
                               does not like to have the first few bytes
                               of the variable section changed by an external 
                               subroutine.  
                            */

extern "C" unsigned int bla_beep;  /* nbr of beeps for dfgnbla */
unsigned char bla_key;             /* keystroke returned by dfgnbla */

main()
{
   clrscr();
   bla_beep = 10;               /*  nbr of beeps  */

   cout << "\n\n  call dfgnbla from C++ program.  see this ";
   cout << "program (blap.cpp) for example";
	cout << "\n\n  dfgnbla will -- beep a user-specified number of times (";
   cout << ("%d",bla_beep);
   cout << " times";
   cout << "\n                  in this case) then cycle silently until ";
   cout << "any key hit";
	cout << "\n  	       -- return the char value of the key that is hit";
	cout << "\n\n  all letters case sensitive";
	cout << "\n\n          a - print a & exit\n          b - print b & exit";
   cout << "\n  any other - exit\n\n  " << endl;

//-------------------------------------------------------
//	beep user-specified nbr of times, 
// then cycle silently until any key hit
// bla_beep = nbr of beeps
// bla_key = char value of key that is hit	
//-------------------------------------------------------

   bla_key = dfgnbla(bla_beep);

	switch(bla_key)
	{
	    case 'a':  cout << "\n  a"; break;
	    case 'b':  cout << "\n  b"; break;
	}
   return(0);
}
