	@echo off

	cls

	rem **************************************************
        rem demo4.bat -- call dpgnbel4 from batch program
	rem           -- use ctl-c to abort batch program
	rem **************************************************

        echo     demo4.bat -- call dpgnbel4 from batch program
        echo dpgnbel4 will -- beep a user-specified number of times
        echo                    (14 times in this case)
        echo               -- then cycle silently until any key hit
        echo               -- return errorlevel 255 if ctrl-x hit
        echo               -- return errorlevel 0 of any other key hit
        echo.
        echo.
	echo **************************************************
	echo                     continue?    
	echo  no = ctrl-x = abort program  yes = any other key
	echo **************************************************

	rem **************************************************
	rem beep 15 times, then cycle silently until any key hit
	rem **************************************************

	echo 14|dpgnbel4

	rem **************************************************
	rem note:  the errorlevel check tests for the specified
	rem        value OR HIGHER.  this batch code line ...
	rem
	rem	   if errorlevel 1 echo one
	rem
	rem	   is executed if the errorlevel is 1 OR HIGHER,
	rem	   (i.e., if errorlevel is 1-255)
	rem
	rem	   therefore, if you check for errorlevel 255 
	rem	   and errorlevel 1, you must check for 
	rem	   errorlevel 255 first and errorlevel 1 second.
	rem	   if you check for errorlevel 1 first, the 
	rem	   errorlevel 1 line will be executed whether
	rem	   the errorlevel is 1 or 255, because it checks
	rem	   for the specified errorlevel OR HIGHER.
	rem **************************************************

	rem **************************************************
	rem errorlevel 255 means ctrl-x hit
	rem **************************************************

	if not errorlevel 255 goto noctrlc

	rem **************************************************
	rem ctrl-x hit
	rem **************************************************

	echo ctrl-x **WAS** hit
 	goto endit

	:noctrlc

	rem **************************************************
	rem errorlevel 1 means bad call to dpgnbel4.  dpgnbel4 
	rem displays error message.  the batch program should
	rem go to end of batch program so that programmer can 
	rem read error message.  to test errorlevel 1, change 
	rem above batch code line from this ...
	rem
	rem " echo 15|dpgnbel4 "        ignore the double quotes (")
	rem
	rem to this ...
	rem 
	rem " echo 1234567|dpgnbel4"      but omit the double quotes (")
	rem **************************************************

	if errorlevel 1 goto endit

	rem **************************************************
	rem ctrl-x **NOT** hit
	rem **************************************************

	echo ctrl-x was **NOT** hit
 
	:endit
